import { Snowflake } from "discord.js";
import { CommandClient } from "./commandclient";
import { Player } from "./models/player";

export class CBClient extends CommandClient {
    async createPlayer(user_id: Snowflake) {
        return await Player.create({
            user_id: user_id,
            start: Math.floor(Date.now()/1000)
        });
    }

    async findOrCreatePlayer(user_id: Snowflake) {
        const player = await Player.findOne({
            where: {
                user_id: user_id
            }
        });

        if (!player) return await this.createPlayer(user_id);
        return player;
    }

    async spendOnPlayer(player: Player, amount: number) {
        const currency = Date.now() - player.start - player.spent;
        
        if (currency - amount < 0) return false;
        await player.update("spent", player.spent+amount);
        return true;
    }

    async grantMoneyToPlayer(player: Player, amount: number) {
        await player.update("spent", player.spent-amount);
        return;
    }
}