import { ApplicationCommandOptionData, ApplicationCommandOptionType, CommandInteraction } from "discord.js"
import { CBClient } from "../cbclient"
import { CHARACTERS } from "../characters"
import { Unit } from "../models/unit"
import { createArgumentsObject, SlashCommand } from "./slash"

export class RollCommand implements SlashCommand {
	name = 'roll'
    description = 'Pull a random character'
    permission = []
    ownerOnly = false
    guildOnly = false
    guildID = "739645806100873328" //for testing
    args: ApplicationCommandOptionData[] = []

	async execute(int: CommandInteraction) {
        const client = int.client as CBClient;
        const player = await client.findOrCreatePlayer(int.user.id);

        if (!(await client.spendOnPlayer(player, 0))) return int.reply({
            content: "You don't have the money!",
            ephemeral: true
        });

        const character = CHARACTERS.random()!;
        await Unit.create({
            user_id: int.user.id,
            character_id: character.id,
            health: character.health,
            speed: character.speed
        });

        return int.reply({
            content: `You got **${character.name}**!`
        });
	}
};
